require 'sketchup.rb'
require 'extensions.rb'

Sketchup.require(File.join(File.dirname(__FILE__), 'DM_Skimp/DMLanguageHandler'))

module DM
  module Skimp

    VERSION = "2.0.0"
    PLUGIN = self
    PLUGIN_NAME = "Skimp".freeze
    LH = DMLanguageHandler.new("skimp.strings")

    if Sketchup.version.to_i >= 20
      ext = SketchupExtension.new(PLUGIN_NAME, (File.join(File.dirname(__FILE__), "DM_Skimp", "load")))
      ext.description = LH["Import and simplify various file formats."]
      ext.version = VERSION
      ext.creator = "mind.sight.studios"
      ext.copyright = "2024, MindSight Studios Inc. 版权所有."
      Sketchup.register_extension(ext, true)
    else
      # Don't localize the string below.  It will not be used often and the inner variables are very useful
      UI.messagebox("需要 SketchUp 2020 或更高版本才能运行 Skimp #{VERSION}. " \
        "请使用扩展管理器卸载或手动删除插件文件.")
      ext = SketchupExtension.new(PLUGIN_NAME, (File.join(File.dirname(__FILE__), "DM_Skimp", "reducer")))
      ext.description = LH["Incompatible with your version of SketchUp"]
      Sketchup.register_extension(ext, true)
    end
  end
end
